const states = global.get('homeassistant.homeAssistant.states')
const stairwellLights = states['light.stairwell_led_strip'].state
const hallwayLights = states['light.hallway_overhead'].state
const earlyNightMode = states['binary_sensor.early_night_mode'].state
const nightMode = states['input_boolean.night_mode'].state
const goodnight = states['input_boolean.goodnight'].state
const masterBedroomSleep = states['input_boolean.master_bedroom_sleeping'].state
const kallenBedroomSleep = states['input_boolean.kallen_sleeping'].state
const peopleSleeping = (masterBedroomSleep === 'on' || kallenBedroomSleep === 'on')
const duration = states['input_number.stairwell_lights_off_delay'].state
const lux = parseInt(states['sensor.stairwell_bottom_illuminance'].state)
const threshold = parseInt(states['input_number.stairwell_lux_threshold'].state)
const payload = msg.payload
const newDuration = duration * 60

let hallwayScene = {}
let hallwayAction = {}

if (payload === 'on') {
    if (goodnight === 'on') {
        hallwayAction = 'off'
    } else if (nightMode === 'on' || (peopleSleeping === true && earlyNightMode === 'on')) {
        hallwayAction = 'on'
        hallwayScene = 'Nightlight'
    } else if (earlyNightMode === 'on') {
        hallwayAction = 'on'
        hallwayScene = 'Adaptive'
    } else {
        hallwayAction = 'off'
    }
}

msg.hallway = hallwayAction
msg.scene = hallwayScene

if (payload === 'on') {
    if (lux <= threshold || stairwellLights === 'on' || hallwayLights === 'on') {
        if (hallwayScene === 'Adaptive') {
            node.send([null,null,msg,msg])
        } else if (hallwayAction === 'on') {
            node.send([null,null,msg,null])
        }
        node.status({fill:'green',shape:'dot',text:'Lights On'})
        node.send([msg,null,null,null])
    } else {
        node.status({fill:'red',shape:'ring',text:'Too bright'})
    }
} else if (payload === 'off') {
    if (stairwellLights === 'on' || hallwayLights === 'on') {
        msg.duration = newDuration
        node.status({fill:"green",shape:"dot",text:parseInt(duration) + ' minutes'})
        node.send([null,msg,null,null])
    } else {
        node.status({fill:"red",shape:"ring",text:"Lights already off"})
    }
}