//! ---------- DAY MODE ----------
// Lists of adaptive lighting switches for different scenarios
const adaptiveDay = [
    "switch.adaptive_lighting_basement_studio",
    "switch.adaptive_lighting_downstairs_bathroom",
    "switch.adaptive_lighting_emma_bedroom",
    "switch.adaptive_lighting_kallen_bedroom",
    "switch.adaptive_lighting_living_room",
    "switch.adaptive_lighting_master_bedroom",
    "switch.adaptive_lighting_mud_room",
    "switch.adaptive_lighting_tina_lamp",
    "switch.adaptive_lighting_upstairs_bathroom",
    "switch.adaptive_lighting_upstairs_hallway",
    "switch.adaptive_lighting_front_porch"
]

const adaptiveDayHoliday = [
    "switch.adaptive_lighting_basement_studio",
    "switch.adaptive_lighting_downstairs_bathroom",
    "switch.adaptive_lighting_emma_bedroom",
    "switch.adaptive_lighting_kallen_bedroom",
    "switch.adaptive_lighting_living_room",
    "switch.adaptive_lighting_master_bedroom",
    "switch.adaptive_lighting_mud_room",
    "switch.adaptive_lighting_tina_lamp",
    "switch.adaptive_lighting_upstairs_bathroom",
    "switch.adaptive_lighting_upstairs_hallway",
]

// List of adaptive lighting sleep mode switches to turn off
const adaptiveSleep = [
    "switch.adaptive_lighting_sleep_mode_basement_studio",
    "switch.adaptive_lighting_sleep_mode_downstairs_bathroom",
    "switch.adaptive_lighting_sleep_mode_emma_bedroom",
    "switch.adaptive_lighting_sleep_mode_kallen_bedroom",
    "switch.adaptive_lighting_sleep_mode_living_room",
    "switch.adaptive_lighting_sleep_mode_master_bedroom",
    "switch.adaptive_lighting_sleep_mode_mud_room",
    "switch.adaptive_lighting_sleep_mode_tina_lamp",
    "switch.adaptive_lighting_sleep_mode_upstairs_bathroom",
    "switch.adaptive_lighting_sleep_mode_upstairs_hallway"
]

// List of selected scene input texts to reset to Adaptive
const selScenesMain = [
    "input_text.basement_studio_selected_scene",
    "input_text.downstairs_bathroom_selected_scene",
    "input_text.emma_bedroom_selected_scene",
    "input_text.front_porch_selected_scene",
    "input_text.kallen_bedroom_selected_scene",
    "input_text.living_room_selected_scene",
    "input_text.master_bedroom_selected_scene",
    "input_text.mud_room_selected_scene",
    "input_text.tina_lamp_selected_scene",
    "input_text.upstairs_bathroom_selected_scene",
    "input_text.upstairs_hallway_selected_scene"
]

// Tina's desk reset
const selScenesTinaDesk = ["input_text.tina_desk_selected_scene"]

// List of booleans to turn off
const booleanOff = [
    "input_boolean.give_me_darkness",
    "input_boolean.goodnight",
    "input_boolean.kallen_computer_updates",
    "input_boolean.night_mode"
]

//! ---------- NIGHT MODE ----------
// Booleans to turn on at night
const adaptiveNight = [
    "switch.adaptive_lighting_front_porch"
]


flow.set("adaptiveDay", adaptiveDay, "diskCon")
flow.set("adaptiveDayHoliday", adaptiveDayHoliday, "diskCon")
flow.set("adaptiveNight", adaptiveNight, "diskCon")
flow.set("adaptiveSleep", adaptiveSleep, "diskCon")
flow.set("selScenesMain", selScenesMain, "diskCon")
flow.set("selScenesTinaDesk", selScenesTinaDesk, "diskCon")
flow.set("booleanOff", booleanOff, "diskCon")